unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Gauges, ComCtrls, ExtCtrls;

type
    TTimerThread = class(TThread)
    protected
        procedure Kick();
        procedure Execute; override;
    end;

  TMainForm = class(TForm)
    Panel1: TPanel;
    RdoYMD: TRadioButton;
    RdoYMDHN: TRadioButton;
    RdoYMDHNS: TRadioButton;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Panel2: TPanel;
    RdoDMF: TRadioButton;
    RdoDSF: TRadioButton;
    RdoDSMF: TRadioButton;
    RdoDF: TRadioButton;
    LblDateModelFile: TLabel;
    LblDateSizeFile: TLabel;
    LblDateSizeModelFile: TLabel;
    LblDateFile: TLabel;
    Panel3: TPanel;
    Button1: TButton;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure MenuVersionClick(Sender: TObject);
    procedure RdoYMDHNSClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    FTimerThread: TTimerThread;
    procedure UpdateForm();
  private
    procedure DoOpen(const APath: String);
  private
    FClientWndProc: Pointer;
    FOrgWndProc: Pointer;
    AllocHandle:HWND;
    FStrBuf: TStringList;
    procedure ClientWndProc(var Msg: TMessage);
  private
    FDateFormat: String;
    procedure UpdateDateFormat();
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  protected
    procedure CreateParams(var Params: TCreateParams); override;
    procedure WMDropFiles(var Msg: TWMDropFiles); message WM_DropFiles;
  private

  end;

var
  MainForm: TMainForm;

//-----------------------------------------------------------------------------
//  dNp̔閧̒l[2008/01/16]
//  http://homepage2.nifty.com/Mr_XRAY/Halbow/Notes/N011.html
const
    UNIQUE_NAM: string = '{352854AC-DD94-4694-8C57-0331489F7656}';
    UNIQUE_NUM: Cardinal = $00001111;

implementation

uses
    ShellApi, Info, FindFile,
    GDIPAPI, GDIPOBJ, GDIPUTIL,
    Math, ComObj;

{$R *.dfm}

//=============================================================================
//  TTimerThread implementation
//=============================================================================

//-----------------------------------------------------------------------------
procedure TTimerThread.Kick();
begin
    MainForm.UpdateForm();
end;

//-----------------------------------------------------------------------------
procedure TTimerThread.Execute();
begin
    while not Terminated do
    begin
        Synchronize(Kick);
        Sleep(10);
    end;
end;

//=============================================================================
//  ŋߎgtH_̏
//=============================================================================

//-----------------------------------------------------------------------------
//  pX  
procedure TMainForm.DoOpen(const APath: String);
var
    LPath: String;
begin
    //  Xbhɒǉ
    LPath := ExpandUNCFileName(APath);
    GFindFileThread.PutPath(LPath);
end;

//=============================================================================
//  TMainForm implementation
//=============================================================================

//-----------------------------------------------------------------------------
//  j[NȃNXw肵ăbZ[WMpEBhE֐[2008/01/16]
//  http://homepage2.nifty.com/Mr_XRAY/Halbow/Notes/N012.html
function AllocMsgWnd(Method: TWndMethod; ClassName:string): HWND;
var
    DummyClass: TWndClass;
begin
    FillChar(DummyClass, SizeOf(TWndClass), #0);
    DummyClass.hInstance := hInstance;
    DummyClass.lpfnWndProc := @DefWindowProc;
    DummyClass.lpszClassName := PChar(ClassName);
    Windows.RegisterClass(DummyClass);
    Result := CreateWindowEx(WS_EX_TOOLWINDOW, DummyClass.lpszClassName,
                             '', WS_POPUP, 0, 0, 0, 0, 0, 0, hInstance, nil);
    if Assigned(Method) then
        SetWindowLong(Result,GWL_WNDPROC,LongInt(Classes.MakeObjectInstance(Method)));
end;

//-----------------------------------------------------------------------------
//  RXgN^[2008/01/16]
//  http://www.borland.co.jp/tips/delphi/dh015/index.html
//  http://homepage2.nifty.com/Mr_XRAY/Halbow/Notes/N012.html
constructor TMainForm.Create(AOwner: TComponent);
begin
    inherited Create(AOwner);
    // \bhƂĒ`EBhEvV[WGg|Cg쐬
    FClientWndProc := Classes.MakeObjectInstance(ClientWndProc);
    // 쐬łAMDI NCAg̃EBhEvV[WƂ
    // o^ÃGgۑ
    if FClientWndProc <> nil then
    begin
        FOrgWndProc := Pointer(SetWindowLong(ClientHandle, GWL_WNDPROC,
                                            Longint(FClientWndProc)));
    end;
    //  bZ[WMp
    if AllocHandle = 0 then AllocHandle := AllocMsgWnd(ClientWndProc, UNIQUE_NAM);
end;

//-----------------------------------------------------------------------------
//  fXgN^[2008/01/16]
//  http://www.borland.co.jp/tips/delphi/dh015/index.html
destructor TMainForm.Destroy;
begin
    // fXgN^ŃEBhEvV[Wɖ߂
    if FOrgWndProc <> nil then
    begin
        SetWindowLong(ClientHandle, GWL_WNDPROC, Longint(FOrgWndProc));
    end;
    //  bZ[WMp
    Classes.DeallocateHwnd(AllocHandle);
    AllocHandle := 0;
    inherited;
end;

//-----------------------------------------------------------------------------
//  ւp̃EBhEvV[W[2008/01/16]
//  http://www.borland.co.jp/tips/delphi/dh015/index.html
//  http://www2.big.or.jp/~osamu/Delphi/tips.cgi?index=268
procedure TMainForm.ClientWndProc(var Msg: TMessage);
var
    i: integer;
    LBuf: PChar;
    LCopyData: PCopyDataStruct;
begin
    case Msg.Msg of

    //  ʂ̃CX^X瑗Ăe
    WM_COPYDATA:
        begin
            LCopyData := PCopyDataStruct(Msg.LParam);
            if LCopyData^.dwData = UNIQUE_NUM then
            begin
                LBuf := StrALloc(LCopyData^.cbData);
                try
                    StrCopy(LBuf, LCopyData^.lpData);
                    FStrBuf.CommaText := LBuf;
                finally
                    StrDispose(LBuf);
                end;
                for i := 0 to FStrBuf.Count - 1 do
                begin
                    //  Xbhɒǉ
                    DoOpen(FStrBuf.Strings[i]);
                end;
            end;
        end;

    //  ̑̑SĂ̏ꍇ
    else
        Msg.Result := CallWindowProc(FOrgWndProc, ClientHandle,
                                        Msg.Msg, Msg.WParam, Msg.LParam);
    end;
end;

//-----------------------------------------------------------------------------
//  tH[\[2008/01/16]
procedure TMainForm.FormShow(Sender: TObject);
var
    i: integer;
begin
    //  NɃACRɃhbvꂽt@C
    for i := 1 to ParamCount do
    begin
        //  Xbhɒǉ
        DoOpen(ParamStr(i));
    end;
end;

//-----------------------------------------------------------------------------
//  GNXv[hbvꂽ̏
//  http://www2.big.or.jp/~osamu/Delphi/tips.cgi?index=0218.txt
procedure TMainForm.WMDropFiles(var Msg: TWMDropFiles);
var
    LPathName: Array[0..MAX_PATH] of Char;
    i, LCount: integer;
begin
    //  hbvꂽt@C̐擾
    LCount := DragQueryFile(Msg.Drop, DWORD(-1), LPathName, SizeOf(LPathName));
    for i := 0 to LCount - 1 do
    begin
        //  ꂼ̃t@C擾
        DragQueryFile(Msg.Drop, i, LPathName, SizeOf(LPathName));
        //  Xbhɒǉ
        DoOpen(LPathName);
    end;
    //  hbv
    DragFinish(Msg.Drop);
end;

//-----------------------------------------------------------------------------
//  GNXv[̃hbOAhhbv󂯕t悤ɂ
//  http://www2.big.or.jp/~osamu/Delphi/tips.cgi?index=0218.txt
procedure TMainForm.CreateParams(var Params: TCreateParams);
begin
    inherited CreateParams(Params);
    Params.ExStyle := Params.EXStyle or WS_EX_ACCEPTFILES;
end;

//-----------------------------------------------------------------------------
//  tH[쐬
procedure TMainForm.FormCreate(Sender: TObject);
begin
    SetFormCaption(Self);
    LoadPropertyFromFile(ChangeFileExt(ParamStr(0), '.ini'), Self);

    //  GpXg쐬
    FStrBuf := TStringList.Create;

    //  I
    UpdateDateFormat();

    //  ^C}[Xbh
    FTimerThread := TTimerThread.Create(False);
    //  XbhJn(쐬͐錾jbg)
    GFindFileThread.Resume();
end;

//-----------------------------------------------------------------------------
//  tH[j
procedure TMainForm.FormDestroy(Sender: TObject);
begin
    //  ^C}[XbhI
    FTimerThread.Free();
    //  LZ(j͐錾jbg)
    GFindFileThread.Cancel();
    //  GpXgj
    FStrBuf.Free;
    //  FormDestroy ̌ FormResize ݂
    Self.OnResize := nil;

    SavePropertyToFile(ChangeFileExt(ParamStr(0), '.ini'), Self);
end;

//-----------------------------------------------------------------------------
//  o[W
procedure TMainForm.MenuVersionClick(Sender: TObject);
begin
    OpenInfoForm();
end;

//-----------------------------------------------------------------------------
//  摜H
function IsImageFile(const AFilePath: String): Boolean;
var
    LImage: TGPImage;
begin
    Result := False;

    //  t@C
    if (FileExists(AFilePath)) then
    begin
        //  ǂݍ
        LImage := TGPImage.Create(AFilePath);
        //  摜Ȃ
        if (LImage.GetType = ImageTypeBitmap) then
        begin
            Result := True;
        end;
        //  
        LImage.Free;
    end;
end;

function CreateThumbnailPng(const AImageName, AThumbName: String; const AMaxSize: Integer): Boolean;
var
    LImage: TGPImage;

    LEncoderClsID: TGUID;
    LEncoderParams: TEncoderParameters;
    LQuality: ULONG;

    LStatus: TStatus;
    LScale: Double;
    LImageSize: Integer;
    LThumbWidth: Integer;
    LThumbHeight: Integer;
    LThumbnail: TGPImage;
begin
    //  t@C
    if (FileExists(AImageName)) then
    begin
        //  ǂݍ
        LImage := TGPImage.Create(AImageName);
        //  摜Ȃ
        if (LImage.GetType = ImageTypeBitmap) then
        begin
            //  摜̃TCY
            LImageSize := Max(LImage.GetWidth, LImage.GetHeight);
            //  {
            LScale := AMaxSize / LImageSize;
            //  TlC̃TCY  
            LThumbWidth := Round(LImage.GetWidth * LScale);
            LThumbHeight := Round(LImage.GetHeight * LScale);
            //  TlC쐬
            LThumbnail := LImage.GetThumbnailImage(LThumbWidth, LThumbHeight, nil, nil);

            //  JPEG  GR[_[NXID 擾
            GetEncoderClsid('image/jpeg', LEncoderClsID);

            //  p[^ݒ肷(kȂ̂ 1 )
            LEncoderParams.Count := 1;
            LEncoderParams.Parameter[0].Guid := EncoderQuality;
            LEncoderParams.Parameter[0].Type_ := EncoderParameterValueTypeLong;
            LEncoderParams.Parameter[0].NumberOfValues := 1;
            //  k
            LQuality := 100;
            LEncoderParams.Parameter[0].Value := @LQuality;

            //  ۑ
            LStatus := LThumbnail.Save(AThumbName, LEncoderClsID, @LEncoderParams);

            //  
            LThumbnail.Free();
            LImage.Free();

            //  Es
            Result := (LStatus = Ok);
        end
        else
        begin
            Result := False;
        end;
    end
    else
    begin
        Result := False;
    end;
end;

//-----------------------------------------------------------------------------
//  ^C}[
procedure TMainForm.UpdateForm();
var
    LFilePath: String;
    LOldName: String;
    LDirPath: String;
    LDateText: String;
    LDimText: String;
    LModelText: String;
    LNewName: String;
    LNewPath: String;
var
    LShell: OleVariant;
    LFolder: OleVariant;
    LFolderItem: OleVariant;
    SCID: String;
var
    LExt: String;
begin
    //  LZ
    if (GetAsyncKeyState(VK_ESCAPE) <> 0) then
    begin
        GFindFileThread.Cancel();
    end;

    //  o
    GFindFileThread.GetResult(FStrBuf, 1);
    if (FStrBuf.Count > 0) then
    begin
        LFilePath := FStrBuf[0];
        FStrBuf.Delete(0);
    end;

    //  摜H
    if (IsImageFile(LFilePath)) then
    begin

        //  t@C
        LOldName := ExtractFileName(LFilePath);
        //  tH_
        LDirPath := ExtractFileDir(LFilePath);

        try
            //  ShellIuWFNg擾
            LShell := CreateOleObject('Shell.Application');
            //  NtH_FolderIuWFNg擾
            LFolder := LShell.NameSpace(OleVariant(LDirPath));
            //  t@C
            LFolderItem := LFolder.ParseName(OleVariant(LOldName));

            //  Be擾
            SCID := '{F29F85E0-4FF9-1068-AB91-08002B27B3D9} 12';
            LDateText := VarToStr(LFolderItem.ExtendedProperty(SCID));
            LDateText := StringReplace(LDateText, ':', '', [rfReplaceAll]);
            LDateText := StringReplace(LDateText, ' ', '', [rfReplaceAll]);

            //  
            LDateText := Copy(LDateText, 1, Length(FDateFormat));

            //  TCY擾
            SCID := 'Dimensions';
            LDimText := VarToStr(LFolderItem.ExtendedProperty(SCID));
            LDimText := StringReplace(LDimText, ' ', '', [rfReplaceAll]);

            //  Jf擾
            SCID := 'CameraModel';
            LModelText := VarToStr(LFolderItem.ExtendedProperty(SCID));
            LModelText := StringReplace(LModelText, ' ', '', [rfReplaceAll]);

            //  V̍쐬
            if (RdoDF.Checked) then
            begin
                LNewName := Format('%s_%s',
                                [LDateText, LOldName]);
            end
            else
            if (RdoDMF.Checked) then
            begin
                LNewName := Format('%s_%s_%s',
                                [LDateText, LModelText, LOldName]);
            end
            else
            if (RdoDSF.Checked) then
            begin
                LNewName := Format('%s_%s_%s',
                                [LDateText, LDimText, LOldName]);
            end
            else
            if (RdoDSMF.Checked) then
            begin
                LNewName := Format('%s_%s_%s_%s',
                                [LDateText, LDimText, LModelText, LOldName]);
            end
            else
            begin
                LNewName := LOldName;
            end;

            //  gq𗎂Ƃ
            LExt := ExtractFileExt(LNewName);
            LNewName := ChangeFileExt(LNewName, '');

            //  pXȂ
            LNewPath := IncludeTrailingPathDelimiter(LDirPath) + LNewName + LExt;

            //  ϊς݂ۂȂ
            if (AnsiPos(LDateText, LOldName) = 0) then
            begin
                RenameFile(LFilePath, LNewPath);
            end;

        except

        end;
        //  
        LFolderItem := Unassigned;
        LFolder := Unassigned;
        LShell := Unassigned;
    end;
end;

//-----------------------------------------------------------------------------
//  ϊ̃t@CɊ܂߂BẽTvXV
procedure TMainForm.UpdateDateFormat();
var
    LDate: String;
begin
    if (RdoYMD.Checked) then
    begin
        FDateFormat := 'YYYYMMDD';
        LDate := RdoYMD.Hint;
    end
    else if (RdoYMDHN.Checked) then
    begin
        FDateFormat := 'YYYYMMDDHHNN';
        LDate := RdoYMDHN.Hint;
    end
    else if (RdoYMDHNS.Checked) then
    begin
        FDateFormat := 'YYYYMMDDHHNNSS';
        LDate := RdoYMDHNS.Hint;
    end
    else
    begin
        FDateFormat := 'YYYYMMDDHHNN';
        LDate := RdoYMDHN.Hint;
    end;

    LblDateFile.Caption := LDate + LblDateFile.Hint;
    LblDateSizeFile.Caption := LDate + LblDateSizeFile.Hint;
    LblDateModelFile.Caption := LDate + LblDateModelFile.Hint;
    LblDateSizeModelFile.Caption := LDate + LblDateSizeModelFile.Hint;
end;

//-----------------------------------------------------------------------------
//  ϊ̃t@CɊ܂߂BȅI
procedure TMainForm.RdoYMDHNSClick(Sender: TObject);
begin
    UpdateDateFormat();
end;

//-----------------------------------------------------------------------------
//  o[W
procedure TMainForm.Button1Click(Sender: TObject);
begin
    OpenInfoForm();
end;

end.
